/*global jQuery, ManageLayoutsDWR */

// Layout Manager Global Data Agent

// binds: atb-hierarchy-load, atb-palette-load, atb-permissions-load
// triggers: atb-hierarchy-updated

(function($) {

	$(document)
		.bind('atb-hierarchy-load', function(event) {
			ManageLayoutsDWR.getHierarchy(function(data) {
				$(event.target).closest('.atb-layout-data').data('atb-hierarchy', data);
				$(event.target).trigger('atb-hierarchy-updated', [data]);
			});
		})

		.bind('atb-palette-load', function(event) {
			ManageLayoutsDWR.getColourScheme(null, function(data) {
				$(event.target).closest('.atb-layout-data').data('atb-palette', data);
//				$(event.target).trigger('atb-palette-updated', [data]);
			});
		})

		.bind('atb-permissions-load', function(event) {
			ManageLayoutsDWR.getGlobalPermissions(function(data) {
				$(event.target).closest('.atb-layout-data').data('atb-permissions', data);
//				$(event.target).trigger('atb-permissions-updated', [data]);
			});
		});

})(jQuery);

