/*global jQuery, alert, confirm */

// Layout Manager Toolbar Agent

// requires: layout-data.js, hierarchy.js

jQuery(function($) {

    function disable(id,state) {
        $('#'+id).attr('aria-disabled', state);
    }


	$('#layout-manager')
		.bind('atb-layout-updated', function(event) {
			var self = $(this),
				layoutData = self.data('atb-layout'),
//				hierarchy = self.data('atb-hierarchy'),
				isDefault = ( layoutData.layoutId === 'DEFAULT' ),
				noEdit = !layoutData.hasPermission('edit'),
				noCopy = !layoutData.hasPermission('child'),
//				noSiblings = (hierarchy[layoutData.parentId] || []).length < 2,
				noSwitch = true;

			disable("toolbar-save", noEdit);
			disable("toolbar-reload", isDefault);
			disable("toolbar-clear", noEdit);
			disable("toolbar-delete", noEdit);
			disable("toolbar-new", noCopy);
			disable("toolbar-duplicate", isDefault || noCopy);
//			disable("toolbar-previous", noSiblings);
//			disable("toolbar-parent", isDefault);
//			disable("toolbar-next", noSiblings);
//			disable("toolbar-switch", noSwitch);
		});


	$('#layout-manager-toolbar')
		.roleSetup();

});

