if (typeof(PagePanelManager)=="undefined") var PagePanelManager = (function () {
    var panels=[];
    function editProp(panelId,prop) {
        var disp = document.getElementById("pagepanel"+panelId+"_display_"+prop);
        if (disp!=null) {
            disp.style.display="none";
        }
        var edit = document.getElementById("pagepanel"+panelId+"_edit_"+prop);
        if (edit!=null) {
            edit.style.display="block";
        }
        var val = document.getElementById("pagepanel"+panelId+"_value_"+prop);
        if (val!=null) {
//            val.focus();
            val.select();
        }
    }

    function propSet(panelId) {
        return function(propData) {
            if (propData==null) {
                return alert("Unable to set value");// this is a bit pants, should privs be checked before allowing them to edit?
            }
            var disp = document.getElementById("pagepanel"+panelId+"_display_"+propData.prop);
            if (disp!=null) {
                disp.innerHTML=propData.value;
                disp.style.display="block";
            }
            var edit = document.getElementById("pagepanel"+panelId+"_edit_"+propData.prop);
            if (edit!=null) {
                edit.style.display="none";
            }
        }
    }

    function setProp(panelId,prop) {
        var val = document.getElementById("pagepanel"+panelId+"_value_"+prop);
        var panelData = panels[panelId];
        if (val!=null && panelData!=null) {
            PagePanelDWR.setProp(panelData.nodeData.id,prop,val.value,propSet(panelId));
        }
    }

    function updatePanel(panelId) {
        return function (props) {
            var panel = document.getElementById("pagepanel"+panelId);
            if (panel!=null) {
                var output="<table>";
                var i=props.length;
                while (-1<--i) {
                    output+="<tr>"
                    output+="<td>"+props[i].prop+"</td>"
                    output+="<td><div onclick='PagePanelManager.editProp(\""+panelId+"\",\""+props[i].prop+"\");' style='cursor:pointer;'>";
                    output+="<div id='pagepanel"+panelId+"_display_"+props[i].prop+"'>"+props[i].value+"</div>";
                    output+="<div style='display:none;' id='pagepanel"+panelId+"_edit_"+props[i].prop+"'>";
                    output+="<input type='text' id='pagepanel"+panelId+"_value_"+props[i].prop+"' value='"+props[i].value+"'>";
                    output+="<input type='button' onclick='PagePanelManager.setProp(\""+panelId+"\",\""+props[i].prop+"\");' value='Set'>";
                    output+="</div>";
                    output+="</div></td>";
                    output+="</tr>"
                }
                output += "</table>";
                panel.innerHTML=output;
            }
        }
    }

    function loadPanel(panelId) {
        return function (nodeData) {
            var panelData = panels[panelId];
            if (panelData!=null) {
                panelData.nodeData=nodeData;
                PagePanelDWR.getProps(nodeData.id,updatePanel(panelId));
            }
        }
    }

    function generatePanel(panelData) {
        var panelId = panels.length;
        panelData.panelId=panelId;
        panels.push(panelData);
        document.write("<div id='pagepanel"+panelId+"'>&nbsp;</div>");
        var lp=loadPanel(panelId);
        if (panelData.nodeData!=null && panelData.nodeData.id!=null && panelData.nodeData.id.length) {
            lp(panelData.nodeData);
        }
        if (panelData.treename!=null && panelData.treename.length) {
            PageTreeManager.addListener(panelData.treename,lp)
        }
    }

    return {editProp:editProp, setProp:setProp, generatePanel:generatePanel};
})();

