/*global jQuery */

(function($) {

$('button.open-layoutbrowser').live('click', function(event) {
	var target = $.dt.attr(event.target, 'data-target', 'idrefs');
	
	$('#layoutbrowser')
		.unbind('dialog-apply.layoutbrowser')
		.bind('dialog-apply.layoutbrowser', function() {
			var layoutId = $.attr(this, 'data-layout');
			if ( layoutId ) {
				target.val(layoutId);
			}
		})
		.attr('aria-hidden', false)
		.attr('data-layout', target.val());
});

})(jQuery);

