/*jslint bitwise: true, eqeqeq: true, nomen: true, undef: true */
/*global jQuery, confirm */

jQuery(function($) {

	var panel = $('#backup-panel');
	
//	$.adaptavist.layouts
//		.dwr()
//		.dwrGo(function() {
//			$.adaptavist.layouts.setup(panel);
//		});

	// Disable controls of a destructive action
	$('.destructive :input', panel).each(function() { this.disabled = true; });

	// Confirm a submit of a destructive action
	$('.destructive :submit', panel).bind('click', function(ev) {
		if (!confirm('Are you sure?')) { ev.preventDefault(); }
	});

	// Enable destructive actions after downloading all layouts
	$('#downloadForm', panel).bind('submit', function() {
		if ($(':selected', this).val() === '@all@') {
			$('.destructive :disabled', panel).each(function() { this.disabled = false; });
		}
	});

	// Bind downloadAll links to submit the download form
	$('.downloadAll', panel).bind('click', function(ev) {
		ev.preventDefault();
		$('#layoutIdSelect', panel).val('@all@');
		$('#downloadForm', panel).submit();
	});

	panel.trigger('ready');
});

